package cn.feast.coding.service.generator;

import cn.feast.coding.mapper.generator.ModuleMapper;
import cn.feast.coding.model.generator.Module;
import cn.feast.coding.model.generator.Page;
import cn.feast.coding.tools.SysContants;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created By FeastCoding.
 */
@Service
public class ModuleService {

    @Autowired
    private ModuleMapper mapper;

    public Integer save(Module module) {
        return mapper.save(module);
    }

    public void update(Module module) {
        mapper.update(module);
    }

    public void deleteById(Integer id) {
        mapper.deleteById(id);
    }

    public int queryByCount(Module module) {
        return mapper.queryByCount(module);
    }

    public List<Module> queryByList(Page page, Module module) {
        String pageQueryCondition = " limit " + page.getStart() + " , " + page.getMaxRows();
        Map<String, Object> paramsMap = new HashMap<String, Object>();
        paramsMap.put("moduleName", module.getModuleName());
        paramsMap.put("moduleDesc", module.getModuleDesc());
        paramsMap.put("moduleMethod", module.getModuleMethod());
        paramsMap.put("moduleDefault", module.getModuleDefault());
        paramsMap.put("pageQueryCondition", pageQueryCondition);
        return mapper.queryByList(paramsMap);
    }

    public List<Module> queryByModule(Module module) {
        return mapper.queryByModule(module);
    }

    public Module queryById(Integer id) {
        return mapper.queryById(id);
    }

    public List<Module> queryAll() {
        return mapper.queryAll();
    }

    public PageInfo<Module> queryPage(Module module, int pageNum, int pageSize) {
        if (pageSize < 1)
            pageSize = SysContants.MAX_PAGE_ROWS;
        PageHelper.startPage(pageNum, pageSize);
        List<Module> list = mapper.queryByModule(module);
        PageInfo pageInfo = new PageInfo(list);
        return pageInfo;
    }
}
